/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  <windows.h>
#include  "../common/graphics/gl_common.h"
#include  "../common/graphics/gl_win.h"
#include  "mtk_text.h"
#include  "mtk_font.h"
#include  "mtk_gl_common.h"
#include  "mtk_image.h"
#include  "mtk_title_page.h"
#include  "mtk_end_roll.h"




//-----------
//  Externs
//-----------
extern char  tyProgram;
extern int	win_w, win_h;

/***/
float	get_animation_frac();
extern bool	bControler;
void	OnCommandSignal();
void	ClearSignal();
bool	GetSignal();
void	WaitForSignal();



//-------------
//  Variables
//-------------
static char  nTitlePage			= TITLEPAGE_CREDITS;	// ^Cg[h̃y[W
static float TitleWidthRatio	= 1.0;
float	TitleDuration = 1.0;
float	TitleZPosIni  = 0.0;
static bool	 bTheaterTitleImageJ	= false;
static bool	 bTheaterTitleImageE	= false;
static mtk_image  TitleImageJ, TitleImageE;


//----------------
//  ^Cgy[W
//----------------
void
draw_image_for_title_page()
{
	float scl = 0.5;
	mtk_image&  TitleImage = (get_language()==LANG_ENG)  ?  TitleImageE  :  TitleImageJ;

	// 摜\
	glPushMatrix();
		glEnable(GL_TEXTURE_2D);
		glDisable(GL_LIGHTING);
		TitleImage.draw(win_w*TitleWidthRatio, win_h);
		glDisable(GL_TEXTURE_2D);
	glPopMatrix();
}


//--- ӎ ---
void
draw_title_page_attention()
{
	draw_title_caution();

	// ^Cgǂݍł
	mtk_image&  TitleImage = (get_language()==LANG_ENG)  ?  TitleImageE  :  TitleImageJ;

	if ( !TitleImage.is_loaded() ) {
		TitleImage.load();
	}

	return;
}


//--- ^Cg ---
void
draw_title_page_title()
{
	// Aj[V̏
	float t = get_animation_frac();
	float rt = get_title_zpos_ini();
	float z  = rt*(1.0-t);
	glTranslatef(0,0,z);

	char lang = get_language();
	if ((bTheaterTitleImageJ && lang!=LANG_ENG) || (bTheaterTitleImageE && lang==LANG_ENG)) {
		glColor4f(1, 1, 1, t);
		draw_image_for_title_page();
	} else {
		float sz = 0.08;
		glScalef(sz,sz,sz);
		glColor4f(0.5,0.7,1,t);
		draw_bilingual_text_line(bszTheaterTitle, TEXT_CENTER, true);
	}
}


//--- e[} ---
void
draw_title_page_theme()
{
	float t = get_animation_frac();
	float sz = 0.06;
	glScalef(sz,sz,sz);
	glTranslatef(0,0.5,0);
	glColor4f(1,1,1,t);
	draw_bilingual_text_line(bszTheme[tyProgram], TEXT_CENTER, true);
	sz = 0.8;
	glScalef(sz,sz,sz);
	glTranslatef(0,-0.5,0);
	draw_bilingual_text_line(bszTheme2[tyProgram], TEXT_CENTER, true);
}


//--- NWbg ---
void
draw_title_page_credits()
{
	// XN[̏
	float t = get_animation_frac();
	draw_credit_roll(t);
	return;
}


void
draw_title_page()
{
	const float screen_w = get_screen_w();

	glDisable(GL_DEPTH_TEST);
	glDisable(GL_LIGHTING);
	glEnable(GL_BLEND);
	glPushMatrix();
		goto_center_screen();

		//*****
		if (nTitlePage == TITLEPAGE_CREDITS) {
			draw_title_page_credits();
		} else if (nTitlePage == TITLEPAGE_ATTENTION) {
			draw_title_page_attention();
		} else if (nTitlePage == TITLEPAGE_TITLE) {
			const float scl = 0.5 * screen_w;
			glScalef(scl, scl, scl);
			draw_title_page_title();
		} else {
			// XN[̕PɃXP[O
			const float scl = screen_w * TitleWidthRatio;
			glScalef(scl, scl, scl);

			switch (nTitlePage) {
				case TITLEPAGE_THEME:		draw_title_page_theme();		break;
				default:	break;
			}
		}
	glPopMatrix();
	glEnable(GL_DEPTH_TEST);
}



//-------------
//  set / get
//-------------
void
set_title_page_no(int idx)
{
	nTitlePage = idx;
}

int
get_title_page_no()
{
	return nTitlePage;
}

void
set_title_width_ratio(float twr)
{
	TitleWidthRatio = twr;
}

float
get_title_width_ratio()
{
	return  TitleWidthRatio;
}

void
set_theater_title_image_J(const char* fn)
{
	if (fn[0] == '\0') {
		bTheaterTitleImageJ = false;
	} else {
		bTheaterTitleImageJ = true;
		TitleImageJ.set_image(fn);
	}
}

void
set_theater_title_image_E(const char* fn)
{
	if (fn[0] == '\0') {
		bTheaterTitleImageE = false;
	} else {
		bTheaterTitleImageE = true;
		TitleImageE.set_image(fn);
	}
}

//  Duraton
void
set_title_duration(float dur)
{
	TitleDuration = dur;
}

float
get_title_duration()
{
	return  TitleDuration;
}

//  ZPos
void
set_title_zpos_ini(float z)
{
	TitleZPosIni = z;
}

float
get_title_zpos_ini()
{
	return  TitleZPosIni;
}
